package com.steerinfo.metermonitor.metermonitorweight.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.metermonitor.dto.MeterMonitorWeightDto;
import com.steerinfo.metermonitor.metermonitorweight.model.MeterMonitorWeight;
import com.steerinfo.metermonitor.metermonitorweight.service.IMeterMonitorWeightService;
import com.steerinfo.meterwork.dto.TimesDto;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterMonitorWeight RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-09-22 07:19
 * 类描述
 * 修订历史：
 * 日期：2020-09-22
 * 作者：generator
 * 参考：
 * 描述：MeterMonitorWeight RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/metermonitorweights")
public class MeterMonitorWeightController extends BaseRESTfulController {

    @Autowired
    IMeterMonitorWeightService meterMonitorWeightService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("metermonitorweight:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterMonitorWeight> list = meterMonitorWeightService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("metermonitorweight:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterMonitorWeight> list = meterMonitorWeightService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterMonitorWeight对象创建")
    @ApiImplicitParam(name = "meterMonitorWeight", value = "详细实体meterMonitorWeight", required = true, dataType = "MeterMonitorWeight")
    //@RequiresPermissions("metermonitorweight:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterMonitorWeight model) {
        try {
            MeterMonitorWeight meterMonitorWeight = meterMonitorWeightService.add(model);
            return success(meterMonitorWeight);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("metermonitorweight:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterMonitorWeight meterMonitorWeight = meterMonitorWeightService.getById(id);
            return success(meterMonitorWeight);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterMonitorWeight信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterMonitorWeight", value = "详细实体meterMonitorWeight", required = true, dataType = "MeterMonitorWeight")
    })
    //@RequiresPermissions("metermonitorweight:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterMonitorWeight model) {
        try {
            model.setId(id);
            MeterMonitorWeight meterMonitorWeight = meterMonitorWeightService.modify(model);
            return success(meterMonitorWeight);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("metermonitorweight:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterMonitorWeightService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "根据时间获取图像列表", notes = "计量场景还原")
    @GetMapping(value = "/listByTime")
    public RESTfulResult listByTime(@RequestParam String actualFirstNo) {
        RESTfulResult rm = failed();
        try {
            List<MeterMonitorWeightDto> mmwds = meterMonitorWeightService.listByTime(actualFirstNo);
            return success(mmwds);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "根据时间段以及计量点获取图像列表", notes = "计量场景还原中弹框")
    @GetMapping(value = "/chartByTime")
    public RESTfulResult chartByTime(@RequestParam HashMap parmas) {
        RESTfulResult rm = failed();
        try {
            List<MeterMonitorWeightDto> mmwds = meterMonitorWeightService.chartByTime(parmas);
            return success(mmwds);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "计量作业最快速度统计趋势")
    @GetMapping(value = "/listFast")
    public RESTfulResult listFast(@RequestParam String spotTypeNo, String collectStartTime, String collectEndTime) {
        RESTfulResult rm = failed();
        try {
            List<TimesDto> mmwds = meterMonitorWeightService.listFast(spotTypeNo, collectStartTime, collectEndTime);
            return success(mmwds);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "计量作业最慢速度统计趋势")
    @GetMapping(value = "/listSlowly")
    public RESTfulResult listSlowly(@RequestParam String spotTypeNo, String collectStartTime, String collectEndTime) {
        RESTfulResult rm = failed();
        try {
            List<TimesDto> mmwds = meterMonitorWeightService.listSlowly(spotTypeNo, collectStartTime, collectEndTime);
            return success(mmwds);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "计量作业平均速度统计趋势")
    @GetMapping(value = "/listAvg")
    public RESTfulResult listAvg(@RequestParam String spotTypeNo, String collectStartTime, String collectEndTime) {
        RESTfulResult rm = failed();
        try {
            List<TimesDto> mmwds = meterMonitorWeightService.listAvg(spotTypeNo, collectStartTime, collectEndTime);
            return success(mmwds);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "Winform创建", notes = "根据MeterMonitorWeight对象创建")
    @ApiImplicitParam(name = "meterMonitorWeight", value = "详细实体meterMonitorWeight", required = true, dataType = "MeterMonitorWeight")
    @PostMapping(value = "/doAddWf", produces = "application/json;charset=UTF-8")
    public RESTfulResult doAddWf(@RequestBody MeterMonitorWeight model) {
        try {
            String no = meterMonitorWeightService.doAddWf(model);
            return success(no);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "Winform修改", notes = "根据MeterMonitorWeight对象修改")
    @ApiImplicitParam(name = "meterMonitorWeight", value = "详细实体meterMonitorWeight", required = true, dataType = "MeterMonitorWeight")
    @PostMapping(value = "/doUpdateWf", produces = "application/json;charset=UTF-8")
    public RESTfulResult doUpdateWf(@RequestBody MeterMonitorWeight model) {
        RESTfulResult rm = failed();
        try {
            String no = meterMonitorWeightService.doUpdateWf(model);
            return success(no);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

}
